/* 
  JSSelector.js
  musiXmatch

  Created by Loreto Parisi on 03/11/11.
  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
*/

// Functions to customize for accessing to innertext and line siblings

//var selectColor = "#fb6a07";
//var normalColor = "#f2f2f2";


function getInnerText(elem) {
    return elem.innerText;
}

function getSiblings(elem) {
    return elem.parentNode.getElementsByTagName("div");
}

/**
 * Native Bridge to JS
 * @param method string Method name
 * @param params array Array of Parameters
 * @param jsCallback JavaScript callback
 */
function comNativeBridge(methodName, paramArray, jSCallback) {
    if(typeof("NativeBridge")!="undefined") { // obj-c 2 JS implementation
        NativeBridge.call(methodName, paramArray, jSCallback);
    }
}

// end customization code

function deselectSiblilngs(elem) {
    var divs = getSiblings(elem);
    for (var i = 0; i < divs.length; i++) {
        var div = divs[i];
        $(div).removeClass("selected");
		div.isMXMSelected = false;
    }
}

function getNextVerse(line) 
{
    var divs = getSiblings(line);
    
    var prev;
    for (var i = 0; i < divs.length; i++) {
        var current = divs[i];
        
        if (prev == line && getInnerText(current) != "")
            return current;
        if (getInnerText(current) != "")
            prev = current;
    }
    return undefined;
}


function getPrevVerse(line) {
    var divs = getSiblings(line);
    
    var prev ;
    for (var i = 0; i < divs.length; i++) {
        var current = divs[i];
        
        if (current == line)
            return prev;
        if (getInnerText(current) != "")
            prev = current;
    }
    return undefined;
}


function areAdiacentVersesSelected(prev,next )
{
    if ((typeof(prev) != "undefined" && prev.isMXMSelected == true) || (typeof(next) != "undefined" && next.isMXMSelected == true))
        return true;
    else
        return false;
}

/**
 * artistName, trackName, trackUrl
 */
function createSharingMessageFB( trackName, artistName, original_verses, maxium_len )
{

    /*
     Versi
     Versi
     titolo - artista
     @musixmatch #lyrics http:...
     se > 140 si toglie:
     - titolo
     - #lyrics
     - artista
     - tronco i versi
     */
    
    var verses_footer_separator = "";
    var title_part = trackName + " ";
    var artist_part = "by " + artistName + "\n";
    var musixmatch_tag = "@musixmatch ";
   
	if (original_verses.length > 0) { // some verses selected
        
		verses_footer_separator = "\n";
		original_verses = '"' + original_verses + '"';
        
        if (original_verses.length + verses_footer_separator.length + title_part.length + artist_part.length < maxium_len)
        {
            return original_verses + verses_footer_separator + title_part + artist_part;
        }
        else if (original_verses.length + verses_footer_separator.length + artist_part.Length < maxium_len)
        {
            return original_verses + verses_footer_separator + artist_part;
        }
        else if (original_verses.length + verses_footer_separator.length + artist_part.length < maxium_len)
        {
            return original_verses + verses_footer_separator + artist_part;
        }
        else if (original_verses.length + verses_footer_separator.length < maxium_len)
        {
            return original_verses + verses_footer_separator;
        }
        else 
        {
            return original_verses.substring(0,maxium_len-5)+ "...\n" ;
        }
	}
    
    else { // no selection
        
        var text = "I just used @musixmatch to discover ";
        text += trackName + " by " + artistName;
        return text;
        
    }
    
}

/**
 * artistName, trackName, trackUrl
 */
function createSharingMessage( trackName, artistName, trackUrl, original_verses, maxium_len )
{
    /*
     Versi
     Versi
     titolo - artista
     @musixmatch #lyrics http:...
     se > 140 si toglie:
     - titolo
     - #lyrics
     - artista
     - tronco i versi
     */
    
    var verses_footer_separator = "";
    var title_part = trackName + " ";
    var artist_part = "by " + artistName + "\n";
    var musixmatch_tag = "@musixmatch ";
    var lyrics_tag =" #lyrics";
    var link = trackUrl;
	
	if (original_verses.length > 0) { // some verses selected
        
		verses_footer_separator = "\n";
		original_verses = '"' + original_verses + '"';
        
        if (original_verses.length + verses_footer_separator.length + title_part.length + artist_part.length + 
            musixmatch_tag.length + lyrics_tag.length + link.length < maxium_len)
        {
            return original_verses + verses_footer_separator + title_part + artist_part + musixmatch_tag + link + lyrics_tag;
        }
        else if (original_verses.length + verses_footer_separator.length + artist_part.Length + 
                 musixmatch_tag.length + lyrics_tag.length + link.length < maxium_len)
        {
            return original_verses + verses_footer_separator + artist_part + musixmatch_tag + link + lyrics_tag;
        }
        else if (original_verses.length + verses_footer_separator.length + artist_part.length + 
                 musixmatch_tag.length + link.length < maxium_len)
        {
            return original_verses + verses_footer_separator + artist_part + musixmatch_tag + link;
        }
        else if (original_verses.length + verses_footer_separator.length + musixmatch_tag.length + link.length < maxium_len)
        {
            return original_verses + verses_footer_separator + musixmatch_tag + link;
        }
        else 
        {
            return original_verses.substring(0,maxium_len-musixmatch_tag.length-link.length-5)+ "...\n" + musixmatch_tag + link ;
        }
	}
    
    else { // no selection
    
        var text = "I just used @musixmatch to discover ";
        text += trackName + " by " + artistName;
        text += " " + link;
        text += " " + lyrics_tag;
        return text;
    
    }
    
}

/**
 * Count selected lines characters
 */
function countSelectedLinesChar()
{
    var divs = document.getElementsByTagName("DIV");
    var sharedText = "" ;
    for (var i = 0; i < divs.length; i++) {
        if (divs[i].isMXMSelected == true) {
            sharedText += sharedText.length > 0 ? "\n" + getInnerText(divs[i]) : getInnerText(divs[i])
        }
    }
    return sharedText.length;
}

/**
 * Get selected lines text 
 */
function getSharedTextFB(trackName, artistName, trackUrl, lenght) 
{
    var divs = document.getElementsByTagName("DIV");
    var sharedText = "" ;
    for (var i = 0; i < divs.length; i++) {
        if (divs[i].isMXMSelected == true) {
            sharedText += sharedText.length > 0 ? "\n" + getInnerText(divs[i]) : getInnerText(divs[i])
        }
    }
    
    return createSharingMessageFB(trackName, artistName, trackUrl, sharedText, lenght);
}

/**
 * Get selected lines text 
 */
function getSharedText(trackName, artistName, trackUrl, lenght) 
{
    var divs = document.getElementsByTagName("DIV");
    var sharedText = "" ;
    for (var i = 0; i < divs.length; i++) {
        if (divs[i].isMXMSelected == true) {
            sharedText += sharedText.length > 0 ? "\n" + getInnerText(divs[i]) : getInnerText(divs[i])
        }
    }
    
    return createSharingMessage(trackName, artistName, trackUrl, sharedText, lenght);
}

/**
 * JavaScript DOM Events callback for touch events
 */
function touched(elem) {
    
    if (elem.isMXMSelected == true) {
        deselectSiblilngs(elem);
        elem.isMXMSelected = false;
        comNativeBridge("textDeselected");
    }
    else {
        var next = getNextVerse(elem);
        var prev = getPrevVerse(elem);
        if (areAdiacentVersesSelected(prev, next) == false) 
        {
            deselectSiblilngs(elem);
        }
        $(elem).addClass("selected");
        elem.isMXMSelected = true;
        comNativeBridge("textSelected");
    }
}

/**
 * Add lyrics to body
 */
function HTMLAddLyrics(element) {
    try {
        $("#body").empty();
        
        $("#body").append(element);
		comNativeBridge("htmlResized");
        
        
        $("#body").scrollTop(0);
        
    } catch(ex) {
        console.log("HTMLAddLyrics"+ex);
        comNativeBridge("lyricsError");
    }
}

function HTMLCleanLyrics() {
    $("#body").empty();
}

/**
 * Add synced lyrics to body
 */
function HTMLAddSyncedLyrics() {
    try {
        
        $("#body").empty();
        
        $("#body").append("<section id=\"synctool\"></section>");
		    comNativeBridge("htmlResized");
        
        $("#body").scrollTop(0);
        
    } catch(ex) {
        console.log("HTMLAddLyrics"+ex);
        comNativeBridge("syncedlyricsError");
    }
}

function CSSShowMessage(mes) {
    
    $("#body").empty();
    $("#body").append("<div class=\"message\">"+mes+"</div>");
    $("#body").show();
    $("#body").scrollTop(0);
    
}


/**
 * Show lyrics body
 */
function CSSShowLyrics() {
    $("#container").show();
}

function CSSChangeFontNameAndSize(fontName,fontSize) {
    $("body").attr("style","font-family:"+fontName+";font-size:"+fontSize+"px;");
    console.log("CSSChangeFontNameAndSize "+fontName + " " + fontSize);
}

/**
 *	Javascript change font style
 */
function CSSChangeFontName(fontName) {
	$("body").attr("style","font-family:"+fontName+";");
}

/**
 * Javascript change font size
 */
function CSSChangeFontSize(fontSize) {
    $("body").attr("style","font-size:"+fontSize+"px;");
}


/**
 *	Javascript toggle night mode
 */
function CSSChangeToggleNightMode(nightMode) {
	if (nightMode) {
		$("body").addClass("nightMode");
	}else {
		$("body").removeClass("nightMode");
	}
}



function setWebViewHeight( height ) {
  console.log( 'setto altezza: ' + height );
  $('#synctool').css('height', height);
  $('#syncatore').css('height', height);  
}

function CSSDone( log ) {
        comNativeBridge("onCSSLoaded");
        console.log(log);
}



/**
 *  JQuery document loaded
 */
$(document).ready(function() {

    comNativeBridge("documentIsReady");

});
