
(function(/*! Stitch !*/) {
  if (!this.require) {
    var modules = {}, cache = {};
    var require = function(name, root) {
      var path = expand(root, name), indexPath = expand(path, './index'), module, fn;
      module   = cache[path] || cache[indexPath];
      if (module) {
        return module;
      } else if (fn = modules[path] || modules[path = indexPath]) {
        module = {id: path, exports: {}};
        cache[path] = module.exports;
        fn(module.exports, function(name) {
          return require(name, dirname(path));
        }, module);
        return cache[path] = module.exports;
      } else {
        throw 'module ' + name + ' not found';
      }
    };
    var expand = function(root, name) {
      var results = [], parts, part;
      // If path is relative
      if (/^\.\.?(\/|$)/.test(name)) {
        parts = [root, name].join('/').split('/');
      } else {
        parts = name.split('/');
      }
      for (var i = 0, length = parts.length; i < length; i++) {
        part = parts[i];
        if (part == '..') {
          results.pop();
        } else if (part != '.' && part != '') {
          results.push(part);
        }
      }
      return results.join('/');
    };
    var dirname = function(path) {
      return path.split('/').slice(0, -1).join('/');
    };
    this.require = function(name) {
      return require(name, '');
    };
    this.require.define = function(bundle) {
      for (var key in bundle) {
        modules[key] = bundle[key];
      }
    };
    this.require.modules = modules;
    this.require.cache   = cache;
  }
  return this.require.define;
}).call(this)({
  "models/lyric_model": function(exports, require, module) {
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  exports.Lyric = (function(_super) {

    __extends(Lyric, _super);

    function Lyric() {
      return Lyric.__super__.constructor.apply(this, arguments);
    }

    return Lyric;

  })(Backbone.Model);

}).call(this);

}, "collections/lyrics_collection": function(exports, require, module) {
(function() {
  var Lyric,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Lyric = require('models/lyric_model').Lyric;

  exports.Lyrics = (function(_super) {

    __extends(Lyrics, _super);

    function Lyrics() {
      return Lyrics.__super__.constructor.apply(this, arguments);
    }

    Lyrics.prototype.model = Lyric;

    Lyrics.prototype.initialize = function(models, options) {
      this.track = options.track;
      this.bind("add", sync.views.app.addOneAfter);
      return this.bind("addSyncLyrics", sync.views.app.addSyncLyrics);
    };

    Lyrics.prototype.toJSON = function() {
      var i, index, line, lyrics, toDelete, _i, _j, _len, _len1;
      lyrics = Lyrics.__super__.toJSON.apply(this, arguments);
      lyrics.splice(0, 1);
      lyrics[lyrics.length - 1].text = "";
      toDelete = [];
      for (index = _i = 0, _len = lyrics.length; _i < _len; index = ++_i) {
        line = lyrics[index];
        if (index > 0) {
          if (line.text === "" && lyrics[index - 1].text === "") {
            toDelete.push(index);
          }
        }
      }
      for (_j = 0, _len1 = toDelete.length; _j < _len1; _j++) {
        i = toDelete[_j];
        lyrics.splice(i, 1);
      }
      if (lyrics[0].text === "") {
        lyrics.splice(0, 1);
      }
      return lyrics;
    };

    Lyrics.prototype.toSimpleJSON = function() {
      var line, lyrics, _i, _len, _ref;
      lyrics = [];
      _ref = this.toJSON();
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        line = _ref[_i];
        lyrics.push({
          x: line.text,
          t: line.time.total
        });
      }
      return lyrics;
    };

    return Lyrics;

  })(Backbone.Collection);

}).call(this);

}, "models/track_model": function(exports, require, module) {
(function() {
  var Lyrics,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Lyrics = require('collections/lyrics_collection').Lyrics;

  exports.Track = (function(_super) {

    __extends(Track, _super);

    function Track() {
      return Track.__super__.constructor.apply(this, arguments);
    }

    Track.prototype.url = function() {};

    Track.prototype.initialize = function() {
      return this.bind("change", this.loaded);
    };

    Track.prototype.loaded = function() {
      this.lyrics = new Lyrics(this.get("lyrics"), {
        track: this
      });
      return sync.views.app.render();
    };

    Track.prototype.getProgress = function() {
      var missing, synced, total;
      total = this.lyrics.size() - 1;
      synced = 0;
      missing = [];
      this.lyrics.each(function(line, index) {
        if (parseFloat(line.get("time").total) === 0) {
          return missing.push(index);
        } else if (index !== 0) {
          return synced++;
        }
      });
      return {
        total: total,
        synced: synced,
        missing: missing
      };
    };

    return Track;

  })(Backbone.Model);

}).call(this);

}, "views/lyric_view": function(exports, require, module) {
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  exports.LyricView = (function(_super) {

    __extends(LyricView, _super);

    function LyricView() {
      this.render = __bind(this.render, this);
      return LyricView.__super__.constructor.apply(this, arguments);
    }

    LyricView.prototype.tagName = "li";

    LyricView.prototype.template = _.template('<div class="controls">\n  <span class="buttons">\n    <a class="play" href="#play" title="Play from here">></a>\n    <a class="add" href="#add" title="Add new line">+<span>Add a missing line</span></a>\n    <a class="remove" href="#remove" title="Remove this line">-<span>Remove this line</span></a>\n    <a class="edit" href="#edit" title="Edit this line">...<span>Edit the lyrics</span></a>\n    <a class="save" href="#edit" title="Save this line edit">...</a>\n  </span>\n</div>\n<div class="text normal">{{ text }}</div>');

    LyricView.prototype.events = {
      "click a.edit": "edit",
      "click a.add": "add",
      "click a.remove": "rem",
      "keydown input": "keydown",
      "blur input": "save",
      "click div.text": "play"
    };

    LyricView.prototype.initialize = function() {
      this.model.view = this;
      return this.model.bind("change", this.render);
    };

    LyricView.prototype.render = function() {
      var currentLine, data, keyword, re, thisLine;
      thisLine = sync.models.track.lyrics.indexOf(this.model);
      currentLine = sync.views.app.currentLine;
      data = this.model.toJSON();
      keyword = sync.models.track.get('keyword');
      if (keyword !== '') {
        re = new RegExp(keyword, "gi");
        data.text = data.text.replace(re, "<span class=\"keyword\">" + keyword + "</span>");
      }
      $(this.el).html(this.template(data));
      if (this.model.get("time").total > 0) {
        $(this.el).addClass("synced");
      }
      if ($.trim(this.model.get("text")) === "") {
        $(this.el).addClass("empty");
      }
      if (thisLine === 0) {
        $(this.el).addClass("intro");
      }
      if (thisLine === sync.models.track.lyrics.length - 1) {
        $(this.el).addClass("outro");
        if (sync.models.track.get("copyright") != null) {
          $(this.el).append('<div class="copyright"></div>');
          $(this.el).find('.copyright').text(sync.models.track.get('copyright'));
        }
      }
      $(this.el).hover(function(event) {
        return $(this).addClass("hover");
      }, function(event) {
        return $(this).removeClass("hover");
      });
      thisLine = sync.models.track.lyrics.indexOf(this.model);
      if (!(currentLine != null)) {
        currentLine = -1;
      }
      if (thisLine === currentLine + 1) {
        $(this.el).addClass("next");
        $(this.el).next().removeClass("next");
      }
      if (thisLine === currentLine - 1 && thisLine > 0) {
        $(this.el).addClass("prev");
        $(this.el).prev().removeClass("next");
      }
      return this;
    };

    LyricView.prototype.edit = function(e) {
      var div, input, text;
      e.preventDefault();
      if ($(this.el).hasClass("editing")) {
        return;
      }
      sync.views.app.trigger("onLineEdit", sync.models.track.lyrics.indexOf(this.model));
      if (sync.views.player.isPlaying()) {
        sync.views.player.play();
        sync.views.app.playOnEdited = true;
      }
      text = this.model.get("text");
      div = $(this.el).children("div.text");
      $(this.el).addClass("editing");
      text = text.replace(/"/g, '&quot;');
      input = $("<input class=\"text\" type=\"text\" name=\"text\" class=\"text\" value=\"" + text + "\" />");
      if (div.hasClass("current")) {
        input.addClass("current");
      }
      div.remove();
      $(this.el).append(input);
      return input.focus();
    };

    LyricView.prototype.play = function(e) {
      var currentLine, thisLine, time;
      if (sync.models.track.get("autoPlay") || (!sync.views.app.clickToSeek && (e != null))) {
        return;
      }
      if (e != null) {
        e.preventDefault();
      }
      time = parseFloat(this.model.get("time").total);
      thisLine = sync.models.track.lyrics.indexOf(this.model);
      currentLine = sync.views.app.currentLine;
      if (sync.views.app.syncing) {
        switch (thisLine) {
          case currentLine + 1:
            return sync.views.app.sync();
          case currentLine - 1:
            sync.views.app.undo();
            if (!sync.views.player.isPlaying()) {
              return sync.views.player.play();
            }
            break;
          case currentLine:
            sync.views.player.seek(time);
            if (!sync.views.player.isPlaying()) {
              return sync.views.player.play();
            }
            break;
          default:
            if (thisLine === 0 && !(currentLine != null)) {
              return sync.views.app.sync();
            }
        }
      } else {
        if (time !== 0) {
          sync.views.app.startScrolling();
          sync.views.player.seek(time);
          if (!sync.views.player.isPlaying()) {
            return sync.views.player.play();
          }
        }
      }
    };

    LyricView.prototype.add = function(e, action) {
      var index;
      if (action == null) {
        action = "";
      }
      e.preventDefault();
      if (!sync.views.app.syncStarted) {
        sync.views.app.setSyncStarted();
      }
      index = sync.models.track.lyrics.indexOf(this.model) + 1;
      sync.models.track.lyrics.add({
        text: "",
        time: {
          total: 0,
          minutes: "",
          seconds: "",
          hundredths: ""
        }
      }, {
        at: index
      });
      sync.models.track.lyrics.at(index).view.render(action);
      if (action === "sync") {
        return sync.views.app.sync();
      } else {
        if (index <= sync.views.app.currentLine) {
          return sync.views.app.currentLine++;
        }
      }
    };

    LyricView.prototype.rem = function(e) {
      var currentLine, prevLine, thisLine;
      e.preventDefault();
      if (!sync.views.app.syncStarted) {
        sync.views.app.setSyncStarted();
      }
      thisLine = sync.models.track.lyrics.indexOf(this.model);
      currentLine = sync.views.app.currentLine;
      if (thisLine === currentLine) {
        prevLine = currentLine > 0 ? currentLine - 1 : null;
        if (prevLine != null) {
          if (sync.views.player.isPlaying()) {
            sync.models.track.lyrics.at(prevLine).view.play();
          } else {
            sync.models.track.lyrics.at(prevLine).view.toggleCurrent(true);
            sync.views.app.currentLine = prevLine;
          }
        } else {
          sync.views.app.currentLine = prevLine;
        }
        if (thisLine > 0) {
          $(this.el).prev().toggleClass("prev");
        }
      }
      if (thisLine === currentLine + 1) {
        if (sync.views.player.isPlaying()) {
          sync.models.track.lyrics.at(currentLine).view.play();
        }
        $(this.el).next().toggleClass("next");
      }
      if (thisLine < currentLine) {
        sync.views.app.currentLine = currentLine - 1;
      }
      sync.models.track.lyrics.remove(this.model);
      return this.remove();
    };

    LyricView.prototype.save = function(e) {
      var currentLine, div, input, item, text, thisLine, time;
      e.preventDefault();
      if (!sync.views.app.syncStarted) {
        sync.views.app.setSyncStarted();
      }
      if (sync.views.app.playOnEdited) {
        thisLine = sync.models.track.lyrics.indexOf(this.model);
        currentLine = sync.views.app.currentLine;
        time = parseFloat(this.model.get("time").total);
        if (time > 0 && thisLine === currentLine) {
          sync.views.player.seek(time);
        }
        sync.views.player.play();
        sync.views.app.playOnEdited = false;
      }
      item = $(this.el);
      item.removeClass("editing");
      sync.views.app.trigger("onLineEditDone", sync.models.track.lyrics.indexOf(this.model));
      if ($(e.target).hasClass("text")) {
        input = $(e.target);
        text = $.trim(input.val());
        text = text.replace(/&quot;/g, '"').replace(/\</g, '&lt;').replace(/\>/g, '&gt;');
        div = $("<div class=\"text normal\">" + text + "\</div>");
        if (input.hasClass("current") && sync.models.track.lyrics.indexOf(this.model) === sync.views.app.currentLine) {
          div.addClass("current");
        }
        try {
          input.remove();
          $(this.el).append(div);
          if (text !== this.model.get("text")) {
            if (text === "" || this.model.get("text") === "") {
              $(this.el).toggleClass("empty");
            }
            return this.model.set({
              text: text
            }, {
              silent: true
            });
          }
        } catch (_error) {}
      } else {
        time = {};
        _.each(item.find("input"), function(input) {
          return time[input.name] = input.value;
        });
        time["total"] = 0;
        if (time["minutes"] !== "") {
          time["total"] += parseInt(time["minutes"], 10) * 60;
        }
        if (time["seconds"] !== "") {
          time["total"] += parseInt(time["seconds"], 10);
        }
        if (time["hundredths"] !== "") {
          time["total"] += parseFloat("0." + time["hundredths"]);
        }
        return this.model.set({
          time: time,
          error: function(model, error) {
            return alert(error);
          }
        });
      }
    };

    LyricView.prototype.keydown = function(e) {
      var _ref;
      if ((_ref = e.keyCode) === 13 || _ref === 27) {
        e.preventDefault();
        return $(e.target).blur();
      }
    };

    LyricView.prototype.toggleCurrent = function(show) {
      var el;
      if (show) {
        sync.views.app.trigger("onCurrentLineChanged", sync.models.track.lyrics.indexOf(this.model));
      }
      $(this.el).siblings().removeClass("current");
      $(this.el).toggleClass("current", show);
      $(this.el).removeClass("next prev");
      $(this.el).siblings().removeClass("next prev");
      if (show) {
        $(this.el).next().addClass("next");
        $(this.el).prev().addClass("prev");
      }
      el = $(this.el).children("div.text");
      if ($(this.el).hasClass("hover")) {
        $(this.el).removeClass("hover");
      }
      if (sync.views.app.transition && !sync.views.app.compact) {
        if (show) {
          el.toggleClass("normal", "current");
          if (sync.views.app.scroll) {
            return _.delay(sync.views.app.scrollLyrics, 200);
          }
        } else {
          return el.toggleClass("current", "normal");
        }
      } else {
        el.toggleClass("normal", !show).toggleClass("current", show);
        if (show) {
          if (sync.views.app.scroll) {
            return _.delay(sync.views.app.scrollLyrics, 1);
          }
        }
      }
    };

    return LyricView;

  })(Backbone.View);

}).call(this);

}, "views/app_view": function(exports, require, module) {
(function() {
  var LyricView,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  LyricView = require('views/lyric_view').LyricView;

  exports.AppView = (function(_super) {

    __extends(AppView, _super);

    function AppView() {
      this.resizeMargins = __bind(this.resizeMargins, this);

      this.playSync = __bind(this.playSync, this);

      this.startScrolling = __bind(this.startScrolling, this);

      this.preventScrolling = __bind(this.preventScrolling, this);

      this.scrollLyrics = __bind(this.scrollLyrics, this);

      this.loadNextLyric = __bind(this.loadNextLyric, this);

      this.addOne = __bind(this.addOne, this);
      return AppView.__super__.constructor.apply(this, arguments);
    }

    AppView.prototype.id = "syncatore";

    AppView.prototype.containerId = null;

    AppView.prototype.track = null;

    AppView.prototype.player = null;

    AppView.prototype.currentLine = null;

    AppView.prototype.lyricsFontSize = null;

    AppView.prototype.syncing = false;

    AppView.prototype.scroll = true;

    AppView.prototype.allowManualScrolling = true;

    AppView.prototype.scrolling = true;

    AppView.prototype.transition = true;

    AppView.prototype.compact = true;

    AppView.prototype.compactSyncing = false;

    AppView.prototype.translate3d = true;

    AppView.prototype.syncStarted = false;

    AppView.prototype.onViewRendered = false;

    AppView.prototype.syncPlayCounter = 0;

    AppView.prototype.playOnEdited = false;

    AppView.prototype.clickToSeek = true;

    AppView.prototype.startTime = 0;

    AppView.prototype.scrollDelay = 100;

    AppView.prototype.manualScrollWaitTime = 5000;

    AppView.prototype.platform = 'universal';

    AppView.prototype.template = _.template('<div class="lyrics">\n  <ol>\n  </ol>\n</div>');

    AppView.prototype.addZero = function(n) {
      if (n < 10) {
        return "0" + n;
      } else {
        return n;
      }
    };

    AppView.prototype.parseTime = function(time) {
      var hundredths, minutes, seconds;
      minutes = this.addZero(Math.floor(time / 60));
      seconds = this.addZero(Math.floor(time) % 60);
      try {
        hundredths = time.toString().split(".")[1].substr(0, 2);
      } catch (error) {
        hundredths = "00";
      }
      if (hundredths.length === "1") {
        hundredths = hundredths + "0";
      }
      return {
        total: time,
        minutes: minutes,
        seconds: seconds,
        hundredths: hundredths
      };
    };

    AppView.prototype.initialize = function() {
      _.extend(this, Backbone.Events);
      _.bindAll(this, 'playTrack');
      _.bindAll(this, 'keydown');
      $(document).bind('keypress', this.playTrack);
      $(document).bind('keydown', this.keydown);
      return $(window).bind('resize', this.resizeMargins);
    };

    AppView.prototype.addOneAfter = function(lyric) {
      var index, view;
      view = new LyricView({
        model: lyric
      });
      index = this.track.lyrics.indexOf(lyric) - 1;
      return $(this.track.lyrics.at(index).view.el).after(view.render().el);
    };

    AppView.prototype.addOne = function(lyric) {
      var view;
      view = new LyricView({
        model: lyric
      });
      return this.$(".lyrics ol").append(view.render().el);
    };

    AppView.prototype.render = function() {
      var container, lyrics;
      this.currentLine = null;
      this.onViewRendered = false;
      $(this.el).removeClass();
      $(this.el).html(this.template());
      this.track = sync.models.track;
      console.log("[SYNCDEBUG] syncatore");
      this.player = sync.views.player;
      if (this.track.get("syncOnLoad")) {
        $(this.el).removeClass("expanded compact");
        if (this.compactSyncing) {
          $(this.el).addClass("compact");
        }
        this.syncing = true;
        this.syncStarted = false;
        $(this.el).addClass("syncing");
      } else {
        $(this.el).addClass("playback");
        if (this.track.get('synced')) {
          if (this.compact) {
            $(this.el).addClass("compact");
          } else {
            $(this.el).addClass("expanded");
          }
        } else {
          $(this.el).removeClass("expanded compact");
        }
      }
      if (this.platform === "android") {
        this.containerId = null;
      }
      if (this.containerId != null) {
        if ($("#" + this.containerId + " #syncatore").length === 0) {
          $("#" + this.containerId).prepend(this.el);
        }
      } else {
        if ($("body #syncatore").length === 0) {
          $('body').prepend(this.el);
        }
      }
      if (this.track.get('synced')) {
        $(this.el).find("div.lyrics").addClass("synced");
      } else {
        $(this.el).find("div.lyrics").addClass("notSynced");
      }
      if (this.lyricsFontSize != null) {
        $(this.el).find("div.lyrics").css('fontSize', this.lyricsFontSize);
      }
      this.track.lyrics.each(this.addOne);
      window.line_scrolling = false;
      container = this.containerId != null ? this.$(".lyrics") : $(window);
      if (this.allowManualScrolling) {
        container.bind('scroll', this.preventScrolling);
      }
      this.debouncedStartScrolling = _.debounce(sync.views.app.startScrolling, this.manualScrollWaitTime);
      if (this.isTouchDevice() && this.isOldWebkit()) {
        $('body').css({
          margin: 0,
          padding: 0
        });
      }
      _.delay(this.resizeMargins, 0);
      if (this.platform !== "android") {
        $(this.el).prepend('<div class="syncBackground"></div>');
      }
      lyrics = this.containerId != null ? this.$(".lyrics") : $("body");
      return lyrics.scrollTop(0);
    };

    AppView.prototype.reset = function(callback) {
      this.currentLine = null;
      this.syncing = false;
      this.scrolling = true;
      this.onViewRendered = false;
      this.syncPlayCounter = 0;
      this.playOnEdited = false;
      $(this.el).removeClass("syncing");
      if (callback != null) {
        return callback();
      }
    };

    AppView.prototype.resetLine = function(line) {
      if (line.get("time").total !== 0.01) {
        return line.set({
          time: {
            hundredths: "",
            minutes: "",
            seconds: "",
            total: 0
          }
        });
      }
    };

    AppView.prototype.resetSync = function() {
      var lyrics, syncing;
      syncing = this.syncing;
      this.syncing = false;
      this.track.lyrics.each(this.resetLine);
      lyrics = this.track.lyrics.toJSON();
      lyrics.splice(0, 0, {
        text: this.intro,
        time: {
          hundredths: "1",
          minutes: "0",
          seconds: "0",
          total: 0.01
        }
      });
      lyrics[lyrics.length - 1].text = this.outro;
      this.track.set({
        id: this.track.id,
        lyrics: lyrics,
        synced: false,
        copyright: this.track.get('copyright')
      });
      this.player.seek(0);
      if (syncing) {
        this.startSyncing();
      }
      this.track.set({
        synced: false
      });
      this.$(".lyrics").removeClass("synced");
      this.$(".lyrics").addClass("notSynced");
      return this.currentLine = null;
    };

    AppView.prototype.loadNextLyric = function() {
      var text;
      if (this.currentLine <= this.track.lyrics.length - 3) {
        text = this.track.lyrics.at(this.currentLine + 2).get("text");
        return $(".previousLine").removeClass("previousLine").addClass("hiddenLine").html(text);
      }
    };

    AppView.prototype.scrollLyrics = function() {
      var container, line, lyric, lyrics, scrollTop,
        _this = this;
      if (!this.scrolling || !this.track || !this.track.get("synced") || !this.scroll) {
        return;
      }
      if (this.containerId != null) {
        lyrics = this.$(".lyrics");
        container = this.$(".lyrics");
      } else {
        lyrics = $('body');
        container = $(window);
      }
      scrollTop = 0;
      if ((this.compact && !this.syncing) || (this.compactSyncing && this.syncing)) {
        if (lyrics.scrollTop(0) !== 0) {
          lyrics.scrollTop(0);
        }
        if (this.syncing) {
          line = this.currentLine;
          lyric = $(this.track.lyrics.at(line).view.el);
          scrollTop = Math.round(lyric.position().top - (container.height() - lyric.outerHeight(true)) / 2);
        } else {
          line = this.currentLine + 1;
          if (this.currentLine === this.track.lyrics.length - 1) {
            line = this.currentLine;
          }
          lyric = $(this.track.lyrics.at(line).view.el);
          scrollTop = Math.round(lyric.position().top - container.height() + lyric.height());
        }
        scrollTop = scrollTop * -1;
        if (this.translate3d) {
          return $("#syncatore ol").css({
            "-webkit-transform": "translate3D(0, " + scrollTop + "px, 0)",
            "-ms-transform": "translate3D(0, " + scrollTop + "px, 0)",
            "-moz-transform": "translate3D(0, " + scrollTop + "px, 0)",
            "-o-transform": "translate3D(0, " + scrollTop + "px, 0)",
            "transform": "translate3D(0, " + scrollTop + "px, 0)"
          });
        } else {
          return $("#syncatore ol").css({
            "-webkit-transform": "translate(0, " + scrollTop + "px)",
            "-ms-transform": "translate(0, " + scrollTop + "px)",
            "-moz-transform": "translate(0, " + scrollTop + "px)",
            "-o-transform": "translate(0, " + scrollTop + "px)",
            "transform": "translate(0, " + scrollTop + "px)"
          });
        }
      } else {
        if (this.currentLine === null) {
          scrollTop = 0;
        } else {
          lyric = $(this.track.lyrics.at(this.currentLine).view.el);
          if (this.containerId != null) {
            scrollTop = Math.round(lyrics.scrollTop() + lyric.position().top - container.height() / 2 + lyric.height() / 2);
          } else {
            scrollTop = Math.round(lyric.position().top - container.height() / 2 + lyric.height() / 2);
          }
        }
        container.unbind('scroll');
        return lyrics.animate({
          scrollTop: scrollTop
        }, this.scrollDelay, function() {
          return _.delay(function() {
            if (_this.allowManualScrolling) {
              return container.bind('scroll', _this.preventScrolling);
            }
          }, _this.scrollDelay);
        });
      }
    };

    AppView.prototype.preventScrolling = function(e) {
      if (!this.syncing) {
        if (this.scrolling) {
          this.stopScrolling();
        }
        return this.debouncedStartScrolling();
      }
    };

    AppView.prototype.toggleCompact = function(compact) {
      if (compact === this.compact) {
        return;
      }
      this.compact = !this.compact;
      if (this.compact) {
        this.$(".lyrics").scrollTop(0);
      } else {
        $("#syncatore ol").css({
          "-webkit-transform": "none",
          "-ms-transform": "none",
          "-moz-transform": "none",
          "-o-transform": "none",
          "transform": "none"
        });
      }
      this.resizeMargins();
      $(this.el).toggleClass("compact");
      $(this.el).toggleClass("expanded");
      this.startScrolling();
      if (this.compact) {
        setTimeout("$('#syncatore .lyrics ol').show()", 1);
      }
      return setTimeout("sync.views.app.scrollLyrics()", 100);
    };

    AppView.prototype.toggleCompactSyncing = function(compactSyncing) {
      if (compactSyncing === this.compactSyncing) {
        return;
      }
      this.compactSyncing = !this.compactSyncing;
      if (this.compactSyncing) {
        $('#syncatore .lyrics ol').hide();
        this.$(".lyrics").scrollTop(0);
      } else {
        $("#syncatore ol").css({
          "-webkit-transform": "none",
          "-ms-transform": "none",
          "-moz-transform": "none",
          "-o-transform": "none",
          "transform": "none"
        });
      }
      this.resizeMargins();
      $(this.el).toggleClass("compact");
      this.startScrolling();
      if (this.compactSyncing) {
        setTimeout("$('#syncatore .lyrics ol').show()", 1);
      }
      return setTimeout("sync.views.app.scrollLyrics()", 100);
    };

    AppView.prototype.toggleSynced = function(synced) {
      if (synced === this.track.get('synced')) {
        return;
      }
      return this.track.set({
        synced: !this.track.get('synced')
      });
    };

    AppView.prototype.sync = function() {
      var lyric, nextTime, prevTime, time;
      if ((!this.player.isPlaying() && this.currentLine !== this.track.lyrics.length - 2) || this.currentLine === this.track.lyrics.length - 1 || window.line_scrolling) {
        return;
      }
      if (this.currentLine !== null) {
        prevTime = this.track.lyrics.at(this.currentLine).get("time").total;
      }
      if (this.currentLine + 2 < this.track.lyrics.length) {
        nextTime = this.track.lyrics.at(this.currentLine + 2).get("time").total;
      }
      time = this.player.getPositionObj();
      if (time.total <= prevTime) {
        return;
      }
      if (time.total >= nextTime && parseFloat(nextTime) !== 0) {
        return;
      }
      window.line_scrolling = true;
      setTimeout("window.line_scrolling = false", 300);
      this.currentLine = this.currentLine !== null ? this.currentLine + 1 : 0;
      lyric = this.track.lyrics.at(this.currentLine);
      lyric.set({
        time: time
      });
      if (this.currentLine > 0) {
        this.track.lyrics.at(this.currentLine - 1).view.toggleCurrent(false);
      }
      lyric.view.toggleCurrent(true);
      $(lyric.view.el).addClass("synced");
      if (this.currentLine === (this.track.lyrics.size() - 1) && this.syncFinished()) {
        this.trigger("onSyncFinished", {
          id: this.track.id,
          lyrics: this.track.lyrics.toJSON()
        });
      }
      if (this.currentLine === 1 && !this.syncStarted) {
        return this.setSyncStarted();
      }
    };

    AppView.prototype.setSyncStarted = function() {
      this.trigger("onSyncStarted", this.track.id);
      $(this.el).find("div.lyrics").addClass("synced");
      $(this.el).find("div.lyrics").removeClass("notSynced");
      this.syncStarted = true;
      return this.track.set({
        synced: true
      }, {
        silent: true
      });
    };

    AppView.prototype.undo = function() {
      var currentTime, time;
      if (this.currentLine === null || this.currentLine === 0) {
        return;
      }
      this.track.lyrics.at(this.currentLine).view.toggleCurrent(false);
      currentTime = this.track.lyrics.at(this.currentLine).get("time").total;
      this.track.lyrics.at(this.currentLine).set({
        time: {
          total: "0",
          minutes: "",
          seconds: "",
          hundredths: ""
        }
      });
      time = 0;
      if (this.currentLine > 0) {
        this.track.lyrics.at(this.currentLine - 1).view.toggleCurrent(true);
        if (this.currentLine > 1) {
          time = this.track.lyrics.at(this.currentLine - 1).get("time").total;
        } else {
          time = currentTime - 3;
        }
      }
      if (time < 0) {
        time = 0;
      }
      this.player.seek(time);
      return this.currentLine = this.currentLine > 0 ? this.currentLine - 1 : null;
    };

    AppView.prototype.toggleSyncing = function() {
      if (this.syncing) {
        return this.stopSyncing();
      } else {
        return this.startSyncing();
      }
    };

    AppView.prototype.startSyncing = function(fromStart) {
      var _this = this;
      if (fromStart == null) {
        fromStart = true;
      }
      if (this.syncing) {
        return;
      }
      this.startScrolling();
      this.syncing = true;
      this.syncStarted = false;
      $(this.el).toggleClass("syncing");
      $(this.el).toggleClass("playback");
      $(this.el).removeClass("compact");
      if (this.compact) {
        $("#syncatore ol").css({
          "-webkit-transform": "none",
          "-ms-transform": "none",
          "-moz-transform": "none",
          "-o-transform": "none",
          "transform": "none"
        });
      }
      if (this.compactSyncing) {
        $(this.el).addClass("compact");
        this.$(".lyrics").scrollTop(0);
      } else {
        $(this.el).removeClass("compact");
      }
      $(this.el).removeClass("expanded");
      $(this.el).find("div.lyrics").css('fontSize', '');
      _.delay((function() {
        return _this.setCurrentLine(0.1);
      }), 5);
      return _.delay((function() {
        return _this.resizeMargins();
      }), 10);
    };

    AppView.prototype.stopSyncing = function() {
      if (!this.syncing) {
        return;
      }
      this.syncing = false;
      $(this.el).toggleClass("syncing");
      $(this.el).toggleClass("playback");
      if (this.compactSyncing) {
        $(this.el).removeClass("compact");
      }
      if (this.compact) {
        $(this.el).addClass("compact");
        this.$(".lyrics").scrollTop(0);
      } else {
        $(this.el).addClass("expanded");
      }
      if (this.lyricsFontSize != null) {
        $(this.el).find("div.lyrics").css('fontSize', this.lyricsFontSize);
      }
      if (this.compactSyncing) {
        $("#syncatore ol").css({
          "-webkit-transform": "none",
          "-ms-transform": "none",
          "-moz-transform": "none",
          "-o-transform": "none",
          "transform": "none"
        });
      }
      this.trigger("onSyncStopped", this.track.id);
      if (this.track.get("synced")) {
        return this.resizeMargins();
      }
    };

    AppView.prototype.startScrolling = function() {
      var container;
      this.scrolling = true;
      container = this.containerId != null ? this.$(".lyrics") : $(window);
      return container.unbind('scroll');
    };

    AppView.prototype.stopScrolling = function() {
      return this.scrolling = false;
    };

    AppView.prototype.playSync = function(counter, trackID, line) {
      var cTime, dTime, nTime;
      if ((!this.player.isPlaying() && !this.track.get('autoPlay')) || counter !== this.syncPlayCounter || this.syncing || trackID !== this.track.id) {
        return;
      }
      if (this.currentLine >= 0 && (this.currentLine != null) && !this.track.get('synced') && !this.syncStarted && !this.syncing) {
        return;
      }
      if (this.currentLine !== null) {
        this.track.lyrics.at(this.currentLine).view.toggleCurrent(false);
        if (this.currentLine < this.track.lyrics.size() - 1) {
          this.track.lyrics.at(this.currentLine + 1).view.toggleCurrent(true);
        }
      } else {
        this.track.lyrics.at(0).view.toggleCurrent(true);
      }
      this.currentLine = this.currentLine !== null ? this.currentLine + 1 : 0;
      if (this.currentLine < this.track.lyrics.size() - 1) {
        nTime = this.track.lyrics.at(this.currentLine + 1).get("time").total * 1000;
        if (nTime > 0) {
          cTime = this.player.getPositionObj().total * 1000;
          dTime = nTime - cTime;
          if (dTime > 200) {
            dTime = dTime - 200;
          } else {
            dTime = 1;
          }
          if (dTime > 0) {
            return this.timer = _.delay(this.playSync, dTime, counter, this.track.id, this.currentLine);
          }
        }
      }
    };

    AppView.prototype.setCurrentLine = function(seconds) {
      var cTime, dTime, i, lastLineTime, linesNo, nTime, newLine, nextLine, play, prevLine, _i, _ref, _ref1;
      if (!this.track.get('synced') && !this.syncing) {
        return;
      }
      this.syncPlayCounter++;
      prevLine = this.currentLine;
      play = this.track.get('autoPlay') ? true : this.player.isPlaying();
      if (seconds != null) {
        cTime = seconds;
      } else {
        cTime = (_ref = this.player.getPositionObj().total) != null ? _ref : 0.1;
      }
      if (cTime === 0) {
        cTime = 0.1;
      }
      linesNo = this.track.lyrics.size();
      for (i = _i = _ref1 = linesNo - 1; _ref1 <= 0 ? _i <= 0 : _i >= 0; i = _ref1 <= 0 ? ++_i : --_i) {
        if (cTime >= this.track.lyrics.at(i).get("time").total && this.track.lyrics.at(i).get("time").seconds !== "") {
          newLine = i;
          break;
        }
      }
      lastLineTime = this.track.lyrics.at(linesNo - 1).get("time").total;
      if (!(newLine != null) && cTime >= lastLineTime && lastLineTime > 0) {
        newLine = linesNo - 1;
      } else if (!(newLine != null)) {
        newLine = -1;
      }
      if ((newLine != null) && newLine !== this.currentLine) {
        if ((this.currentLine != null) && this.currentLine > -1) {
          this.track.lyrics.at(this.currentLine).view.toggleCurrent(false);
        }
        if ((newLine != null) && newLine > -1) {
          this.track.lyrics.at(newLine).view.toggleCurrent(true);
          this.currentLine = newLine;
          this.startScrolling();
        } else {
          this.currentLine = null;
        }
      }
      if (play && this.currentLine !== linesNo - 1) {
        cTime = cTime * 1000;
        nextLine = this.currentLine !== null ? this.currentLine + 1 : 0;
        nTime = this.track.lyrics.at(nextLine).get("time").total * 1000;
        if (nTime > 0) {
          dTime = nTime - cTime;
          if (dTime > 200) {
            dTime = dTime - 200;
          } else {
            dTime = 1;
          }
          if (dTime > 0) {
            return this.timer = _.delay(this.playSync, dTime, this.syncPlayCounter, this.track.id, this.currentLine);
          }
        }
      }
    };

    AppView.prototype.seekToLastSynced = function() {
      var i, time, _i, _ref;
      for (i = _i = _ref = this.track.lyrics.size() - 1; _ref <= 0 ? _i <= 0 : _i >= 0; i = _ref <= 0 ? ++_i : --_i) {
        time = parseFloat(this.track.lyrics.at(i).get("time").total);
        if (time !== 0) {
          return this.player.seek(time);
        }
      }
    };

    AppView.prototype.seekToLine = function(lineNo) {
      var time;
      time = parseFloat(this.track.lyrics.at(lineNo).get("time").total);
      if (time !== 0) {
        return this.player.seek(time);
      }
    };

    AppView.prototype.syncFinished = function() {
      var i, _i, _ref;
      for (i = _i = _ref = this.track.lyrics.size() - 1; _ref <= 0 ? _i <= 0 : _i >= 0; i = _ref <= 0 ? ++_i : --_i) {
        if (parseFloat(this.track.lyrics.at(i).get("time").total) === 0 && i !== 0) {
          return false;
        }
      }
      return true;
    };

    AppView.prototype.keydown = function(e) {
      if ($(e.target).is("input, select, textarea") || !this.syncing || $(e.target).hasClass("keysControl")) {
        return;
      }
      switch (e.keyCode) {
        case 40:
        case 39:
        case 83:
        case 68:
          e.preventDefault();
          return this.sync();
        case 37:
        case 38:
        case 65:
        case 87:
          if (!this.player.isPlaying()) {
            return;
          }
          e.preventDefault();
          return this.undo();
      }
    };

    AppView.prototype.playTrack = function(e) {
      if (e.charCode !== 32 || $(e.target).is("input, select, textarea") || $(e.target).hasClass("keysControl")) {
        return;
      }
      e.preventDefault();
      return this.player.play();
    };

    AppView.prototype.resizeMargins = function(e) {
      var containerHeight, line, lineHeight, linesHeight, margin, marginTop,
        _this = this;
      if (!(this.track != null)) {
        return;
      }
      if (this.track.get("syncOnLoad") && this.syncing && !this.onViewRendered) {
        this.setCurrentLine(0.1);
      }
      if (!this.track.get("synced") && !this.syncing) {
        if (!this.onViewRendered && !(e != null)) {
          this.onViewRendered = true;
          this.trigger("onViewRendered");
          console.log("Syncatore loading time is " + (Date.now() - this.loadStartTime) + " milliseconds");
        }
        return;
      }
      this.trigger("onSizeChange", this.track.id);
      if (!this.syncing) {
        if (this.track.get('autoPlay') && !this.onViewRendered) {
          this.setCurrentLine(this.track.get('startPosition'));
          this.startTime = Date.now();
        } else {
          this.setCurrentLine();
        }
      }
      if (!(this.containerId != null)) {
        if ((this.compact && !this.syncing) || (this.compactSyncing && this.syncing)) {
          this.$(".lyrics").height($(window).height());
        } else {
          this.$(".lyrics").height("auto");
        }
      }
      containerHeight = this.containerId != null ? this.$(".lyrics").height() : $(window).height();
      if (this.compact && !this.syncing) {
        if (this.currentLine != null) {
          line = this.currentLine < this.track.lyrics.size() - 1 ? this.currentLine + 1 : this.currentLine - 1;
          linesHeight = $(this.track.lyrics.at(this.currentLine).view.el).outerHeight(true) + $(this.track.lyrics.at(line).view.el).outerHeight(true);
        } else {
          linesHeight = $(this.track.lyrics.at(0).view.el).outerHeight(true) + $(this.track.lyrics.at(1).view.el).outerHeight(true);
        }
        margin = parseInt(containerHeight - linesHeight);
        marginTop = 0;
      } else {
        if (this.currentLine != null) {
          lineHeight = $(this.track.lyrics.at(this.currentLine).view.el).outerHeight(true);
        } else {
          lineHeight = $(this.track.lyrics.at(0).view.el).height();
        }
        margin = parseInt((containerHeight - lineHeight) / 2);
        marginTop = margin - this.$(".lyrics .copyright").outerHeight(true);
      }
      this.$(".lyrics ol").css({
        "padding-top": "" + margin + "px"
      });
      this.$(".lyrics .copyright").css({
        "padding-bottom": "" + marginTop + "px"
      });
      $(this.el).find("div.lyrics ol").css("margin-top", "0");
      _.delay((function() {
        return $(_this.el).hide();
      }), 0);
      _.delay((function() {
        return $(_this.el).show();
      }), 0);
      _.delay((function() {
        return _this.scrollLyrics();
      }), 0);
      if (!this.onViewRendered && !(e != null)) {
        this.onViewRendered = true;
        this.trigger("onViewRendered");
        return console.log("Syncatore loading time is " + (Date.now() - this.loadStartTime) + " milliseconds");
      }
    };

    AppView.prototype.removeMargins = function() {
      this.$(".lyrics ol").css("padding", "0");
      return this.$(".lyrics copyright").css("padding", "0");
    };

    AppView.prototype.changeLyricsFontSize = function(size) {
      $(this.el).find("div.lyrics").css('fontSize', size);
      this.lyricsFontSize = size;
      this.resizeMargins();
      return this.scrollLyrics();
    };

    AppView.prototype.setFirstAsNext = function() {
      this.$(".lyrics ol li.next").toggleClass("next");
      return this.$(".lyrics ol li:first").toggleClass("next");
    };

    AppView.prototype.hide = function() {
      return $(this.el).css("opacity", "0");
    };

    AppView.prototype.show = function() {
      return $(this.el).css("opacity", "1");
    };

    AppView.prototype.getCurrentLine = function() {
      var line;
      if (this.currentLine != null) {
        line = this.track.lyrics.at(this.currentLine);
        if (this.currentLine === this.track.lyrics.length - 1) {
          return {
            text: this.outro,
            time: line.get('time').total
          };
        } else {
          return {
            text: line.get('text'),
            time: line.get('time').total
          };
        }
      } else {
        return {
          text: this.intro,
          time: 0
        };
      }
    };

    AppView.prototype.getPrevLine = function() {
      var line;
      if ((this.currentLine != null) && this.currentLine > 0) {
        line = this.track.lyrics.at(this.currentLine - 1);
        return {
          text: line.get('text'),
          time: line.get('time').total
        };
      } else {
        return {
          text: this.intro,
          time: 0
        };
      }
    };

    AppView.prototype.getNextLine = function() {
      var line;
      if ((this.currentLine != null) && this.currentLine < this.track.lyrics.length - 1) {
        line = this.track.lyrics.at(this.currentLine + 1);
        return {
          text: line.get('text'),
          time: line.get('time').total
        };
      } else {
        if (this.currentLine === this.track.lyrics.length - 1) {
          return null;
        } else {
          return {
            text: this.intro,
            time: 0
          };
        }
      }
    };

    AppView.prototype.setStartPosition = function(position) {
      this.track.set({
        startPosition: position
      }, {
        silent: true
      });
      this.setCurrentLine(position);
      return this.startTime = Date.now();
    };

    AppView.prototype.isTouchDevice = function() {
      try {
        document.createEvent("TouchEvent");
        return true;
      } catch (e) {
        return false;
      }
    };

    AppView.prototype.isOldWebkit = function() {
      var _ref;
      if (!$.browser.webkit) {
        return false;
      }
      if ((_ref = $.browser.version) === '530.17' || _ref === '533.1') {
        return true;
      } else {
        return false;
      }
    };

    return AppView;

  })(Backbone.View);

}).call(this);

}, "views/player_view": function(exports, require, module) {
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  exports.PlayerView = (function(_super) {

    __extends(PlayerView, _super);

    function PlayerView() {
      return PlayerView.__super__.constructor.apply(this, arguments);
    }

    PlayerView.prototype.initialize = function() {};

    PlayerView.prototype.stateChanged = function(state) {
      var app;
      if (!(sync.models.track.get("id") != null) || sync.views.app.autoPlay) {
        return;
      }
      app = sync.views.app;
      if (app.syncing) {
        switch (state) {
          case 'paused':
            return app.trigger("onSyncPaused", sync.models.track.id);
          case 'stopped':
            return app.trigger("onSyncStopped", sync.models.track.id);
        }
      } else {
        switch (state) {
          case 'playing':
            return app.setCurrentLine();
          case 'paused':
          case 'stopped':
            return app.syncPlayCounter++;
        }
      }
    };

    PlayerView.prototype.positionChanged = function(seconds) {
      var app;
      if (!(sync.models.track.get("id") != null) || sync.views.app.autoPlay) {
        return;
      }
      app = sync.views.app;
      if (!app.syncing) {
        app.startScrolling();
        return app.setCurrentLine(seconds);
      }
    };

    PlayerView.prototype.render = function() {};

    PlayerView.prototype.isAvailable = function() {
      return true;
    };

    PlayerView.prototype.play = function() {};

    PlayerView.prototype.isPlaying = function() {};

    PlayerView.prototype.getPosition = function() {};

    PlayerView.prototype.getPositionObj = function() {
      var time;
      time = 0;
      if (sync.models.track.get('autoPlay')) {
        time = (Date.now() - sync.views.app.startTime) / 1000 + sync.models.track.get('startPosition');
      } else {
        time = this.getPosition();
      }
      time = Math.round(time * Math.pow(10, 2)) / Math.pow(10, 2);
      return sync.views.app.parseTime(time);
    };

    PlayerView.prototype.seek = function(seconds) {};

    PlayerView.prototype.showLyrics = function(show) {};

    PlayerView.prototype.loadLyrics = function(url) {};

    return PlayerView;

  })(Backbone.View);

}).call(this);

}, "routers/main_router": function(exports, require, module) {
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  exports.MainRouter = (function(_super) {

    __extends(MainRouter, _super);

    function MainRouter() {
      return MainRouter.__super__.constructor.apply(this, arguments);
    }

    MainRouter.prototype.load = function(params) {
      var autoPlay, compact, copyright, i, id, keyword, line, lines, linesCopy, lyrics, newLine, newLines, offset, startPosition, syncOnLoad, synced, word, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      sync.views.app.loadStartTime = Date.now();
      id = params.id;
      lyrics = params.lyrics;
      copyright = (_ref = params.copyright) != null ? _ref : "";
      autoPlay = (_ref1 = params.autoPlay) != null ? _ref1 : false;
      startPosition = (_ref2 = params.startPosition) != null ? _ref2 : 0;
      compact = params.compact;
      syncOnLoad = (_ref3 = params.syncOnLoad) != null ? _ref3 : false;
      keyword = (_ref4 = params.keyword) != null ? _ref4 : "";
      if (!(id != null) && (lyrics != null)) {
        return;
      }
      if (compact != null) {
        sync.views.app.compact = compact;
      }
      synced = true;
      if (typeof lyrics === "string") {
        lyrics = lyrics.replace(/(\r)+/g, "").replace(/(\n){2,}/g, "\n");
        lines = lyrics.split("\n");
        linesCopy = lines.slice(0);
        offset = 0;
        for (i = _i = 0, _len = lines.length; _i < _len; i = ++_i) {
          line = lines[i];
          if (line.length > 80) {
            newLines = [];
            newLine = '';
            _ref5 = line.split(' ');
            for (_j = 0, _len1 = _ref5.length; _j < _len1; _j++) {
              word = _ref5[_j];
              if (newLine.length <= 80) {
                newLine += " " + word;
              } else {
                newLines.push(newLine);
                newLine = word;
              }
            }
            newLines.push(newLine);
            linesCopy.splice.apply(linesCopy, [i + offset, 1].concat(newLines));
            offset += newLines.length - 1;
          }
        }
        lines = linesCopy.slice(0);
        lyrics = (function() {
          var _k, _len2, _results;
          _results = [];
          for (_k = 0, _len2 = lines.length; _k < _len2; _k++) {
            line = lines[_k];
            _results.push({
              text: $.trim(line),
              time: {
                hundredths: "",
                minutes: "",
                seconds: "",
                total: 0
              }
            });
          }
          return _results;
        })();
        synced = false;
        lyrics.push({
          text: sync.views.app.outro,
          time: {
            hundredths: "",
            minutes: "",
            seconds: "",
            total: 0
          }
        });
      } else {
        if (lyrics[0].x) {
          if (sync.models.player.isAvailable()) {
            lyrics = (function() {
              var _k, _len2, _results;
              _results = [];
              for (_k = 0, _len2 = lyrics.length; _k < _len2; _k++) {
                line = lyrics[_k];
                _results.push({
                  text: line.x,
                  time: sync.views.app.parseTime(line.t)
                });
              }
              return _results;
            })();
          } else {
            lyrics = (function() {
              var _k, _len2, _results;
              _results = [];
              for (_k = 0, _len2 = lyrics.length; _k < _len2; _k++) {
                line = lyrics[_k];
                _results.push({
                  text: line.x,
                  time: {
                    hundredths: "",
                    minutes: "",
                    seconds: "",
                    total: 0
                  }
                });
              }
              return _results;
            })();
            synced = false;
          }
        } else {
          if (!sync.views.player.isAvailable()) {
            for (_k = 0, _len2 = lyrics.length; _k < _len2; _k++) {
              line = lyrics[_k];
              line.time = {
                hundredths: "",
                minutes: "",
                seconds: "",
                total: 0
              };
            }
            synced = false;
          }
        }
        lyrics[lyrics.length - 1].text = sync.views.app.outro;
      }
      if (lyrics[0].text === "") {
        lyrics.splice(0, 1);
      }
      lyrics.splice(0, 0, {
        text: sync.views.app.intro,
        time: {
          hundredths: "1",
          minutes: "0",
          seconds: "0",
          total: 0.01
        }
      });
      params = {
        id: id,
        lyrics: lyrics,
        synced: synced,
        copyright: copyright,
        initialLyrics: lyrics,
        initialSynced: synced,
        autoPlay: autoPlay,
        startPosition: startPosition,
        syncOnLoad: syncOnLoad,
        keyword: keyword
      };
      if (sync.models.track.lyrics) {
        sync.models.track.clear({
          silent: true
        });
        sync.views.app.reset(function() {
          return sync.models.track.set(params);
        });
      } else {
        sync.models.track.set(params);
      }
      return sync.views.app.trigger("onLyricsLoaded");
    };

    MainRouter.prototype.reload = function() {
      var params;
      sync.views.app.loadStartTime = Date.now();
      sync.views.app.reset();
      params = {
        id: sync.models.track.get('id'),
        lyrics: sync.models.track.get('initialLyrics'),
        synced: sync.models.track.get('initialSynced'),
        copyright: sync.models.track.get('copyright'),
        initialLyrics: sync.models.track.get('initialLyrics'),
        initialSynced: sync.models.track.get('initialSynced'),
        syncOnLoad: false
      };
      sync.models.track.set(params, {
        silent: true
      });
      return sync.models.track.trigger("change");
    };

    MainRouter.prototype.save = function() {
      var lyrics;
      lyrics = sync.models.track.lyrics.toJSON();
      lyrics[lyrics.length - 1].text = sync.views.app.outro;
      lyrics.splice(0, 0, {
        text: sync.views.app.intro,
        time: {
          hundredths: "1",
          minutes: "0",
          seconds: "0",
          total: 0.01
        }
      });
      return sync.models.track.set({
        initialLyrics: lyrics,
        initialSynced: sync.models.track.get('synced')
      }, {
        silent: true
      });
    };

    MainRouter.prototype.setup = function(options) {
      sync.views.app.intro = options.intro;
      sync.views.app.outro = options.outro;
      if (options.containerId != null) {
        sync.views.app.containerId = options.containerId;
      }
      if (options.compact != null) {
        sync.views.app.compact = options.compact;
      }
      if (options.compactSyncing != null) {
        sync.views.app.compactSyncing = options.compactSyncing;
      }
      if (options.translate3d != null) {
        sync.views.app.translate3d = options.translate3d;
      }
      if (options.clickToSeek != null) {
        sync.views.app.clickToSeek = options.clickToSeek;
      }
      if (options.platform != null) {
        sync.views.app.platform = options.platform;
      }
      if (options.scroll != null) {
        sync.views.app.scroll = options.scroll;
      }
      if (options.scrollDelay != null) {
        sync.views.app.scrollDelay = options.scrollDelay;
      }
      if (options.manualScrollWaitTime != null) {
        return sync.views.app.manualScrollWaitTime = options.manualScrollWaitTime;
      }
    };

    MainRouter.prototype.clean = function() {
      if (!(sync.views.app.containerId != null)) {
        $(window).unbind('scroll');
      }
      if (sync.views.app.timer != null) {
        clearTimeout(sync.views.app.timer);
      }
      sync.views.app.remove();
      return sync.models.track.set({
        id: 0,
        lyrics: [],
        synced: false,
        copyright: '',
        initialLyrics: [],
        initialSynced: false,
        autoPlay: false,
        syncOnLoad: false
      });
    };

    return MainRouter;

  })(Backbone.Router);

}).call(this);

}, "sync": function(exports, require, module) {
(function() {
  var AppView, MainRouter, PlayerView, Track;

  _.templateSettings = {
    interpolate: /\{\{(.+?)\}\}/g
  };

  window.sync = {};

  sync.routers = {};

  sync.models = {};

  sync.collections = {};

  sync.views = {};

  Track = require('models/track_model').Track;

  AppView = require('views/app_view').AppView;

  PlayerView = require('views/player_view').PlayerView;

  MainRouter = require('routers/main_router').MainRouter;

  sync.initialize = function() {
    sync.models.track = new Track();
    sync.views.app = new AppView();
    sync.views.player = new PlayerView();
    return sync.routers.main = new MainRouter();
  };

  sync.initialize();

}).call(this);

}
});
(function() {

  $(document).ready(function() {
    require('sync');
    window.syncatore = sync.routers.main;
    window.syncatore.app = sync.views.app;
    window.syncatore.track = sync.models.track;
    return window.syncatore.player = sync.views.player;
  });

}).call(this);
